
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.FileDialog;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedInputStream;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.SwingConstants;


/**
 *
 * @author sebastien laborie and antoine zimmermann
 */
public class SPARQLRDFApplet extends JApplet {
    
    JTextArea in, out, status;
    
    JButton load, submit, save, clear;
    
    Container content, texts, buttons, statusContent, textAndLabelSPARQL, textAndLabelRDF;
    
    JScrollPane scrollIn, scrollOut;
    
    JLabel sparql, rdf;
    
    public void init() {
        texts = new Container();
        buttons = new Container();
        statusContent = new Container();
        textAndLabelSPARQL = new Container();
        textAndLabelRDF = new Container();
        texts.setLayout(new FlowLayout());
        buttons.setLayout(new FlowLayout());
        statusContent.setLayout(new FlowLayout());
        textAndLabelSPARQL.setLayout(new BorderLayout());
        textAndLabelRDF.setLayout(new BorderLayout());
        
        sparql = new JLabel("SPARQL input", SwingConstants.CENTER);
        rdf = new JLabel("SPARQL/RDF output", SwingConstants.CENTER);
        
        in = new JTextArea("", 15, 30);
        in.setEditable(true);
        scrollIn = new JScrollPane(in);
        out = new JTextArea("", 15, 30);
        out.setBackground(new Color(230,230,230));
        out.setEditable(false);
        scrollOut = new JScrollPane(out);
        status = new JTextArea("", 1, 60);
        status.setEditable(false);
        
        textAndLabelSPARQL.add(sparql, BorderLayout.NORTH);
        textAndLabelSPARQL.add(scrollIn, BorderLayout.SOUTH);
        textAndLabelRDF.add(rdf, BorderLayout.NORTH);
        textAndLabelRDF.add(scrollOut, BorderLayout.SOUTH);
        
        load = new JButton("Load");
        submit = new JButton("Submit");
        save = new JButton("Save");
        save.setEnabled(false);
        clear = new JButton("Clear");
        
        content = getContentPane();
        content.setBackground(Color.white);
        content.setLayout(new BorderLayout()); 
        
        texts.add(textAndLabelSPARQL);
        texts.add(textAndLabelRDF);
        
        statusContent.add(status);
        
        buttons.add(load);
        buttons.add(submit);
        buttons.add(save);
        buttons.add(clear);
        
        content.add(texts, BorderLayout.NORTH);
        content.add(statusContent, BorderLayout.CENTER);
        content.add(buttons, BorderLayout.SOUTH);
        
        ActionListener loadListener = new ActionListener(){
            public void actionPerformed(ActionEvent ae){
                Frame parent = new Frame();
                FileDialog myFileDialog = new FileDialog(parent, "Please choose a file containing a SPARQL query:", FileDialog.LOAD);
                myFileDialog.show();
                File file = new File(myFileDialog.getDirectory() + File.separator + myFileDialog.getFile());
                try {
                    int arrlen = 10000;
                    byte[] infile = new byte[arrlen];

                    FileInputStream fis = new FileInputStream(file); 
                    BufferedInputStream bis = new BufferedInputStream(fis);
                    DataInputStream dis = new DataInputStream(bis);
                    int filelength = dis.read(infile);
                    String filestring = new String(infile, 0, filelength);
                    in.setText(filestring);
                    fis.close();
                }
                catch(FileNotFoundException e){
                    System.out.println(e);
                }
                catch(IOException e){
                    System.out.println(e);
                }                
            }  
        };
        
        ActionListener submitListener = new ActionListener(){
            public void actionPerformed(ActionEvent ae){
                try{
                    out.setText(Sparql.main(in.getText()));
                    status.setForeground(new Color(0,150,0));
                    status.setText("Syntax is OK.");
                    save.setEnabled(true);
                }
                catch (ParseException e) {
                    out.setText("");
                    status.setForeground(new Color(150,0,0));
                    status.setText("Syntax checked failed.");
                    save.setEnabled(false);
		}
		catch (TokenMgrError e) {
                    out.setText("");
                    status.setForeground(new Color(150,0,0));
                    status.setText("Syntax checked failed.");
                    save.setEnabled(false);
		}
            }  
        };
        
        ActionListener saveListener = new ActionListener(){
            public void actionPerformed(ActionEvent ae){
                Frame parent = new Frame();
                FileDialog myFileDialog = new FileDialog(parent, "Please choose a file name in order to store the SPARQL/RDF output:", FileDialog.SAVE);
                myFileDialog.show();
                File file = new File(myFileDialog.getDirectory() + File.separator + myFileDialog.getFile());
                try {
                    FileWriter fw = new FileWriter(file);
                    fw.write(out.getText());
                    fw.close();
		}
                catch(IOException e){
                    System.out.println(e);
		}               
            }  
        };
        
        ActionListener clearListener = new ActionListener(){
            public void actionPerformed(ActionEvent ae){
                in.setText("");
                out.setText("");
                status.setText("");
                save.setEnabled(false);
            }  
        };
        
        load.addActionListener(loadListener);
        submit.addActionListener(submitListener);
        save.addActionListener(saveListener);
        clear.addActionListener(clearListener);
        
    }
    
    

}