/* Generated By:JavaCC: Do not edit this line. Sparql.java */
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.FileOutputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.StringBufferInputStream;
import java.io.StringWriter;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Iterator;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.FactoryConfigurationError;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerFactoryConfigurationError;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Text;

class Sparql implements SparqlConstants {

        private static Document document;

        private static final String SPARQL_NS = "http://exmo.inrialpes.fr/sparql#";
        private static final String RDF_NS = "http://www.w3.org/1999/02/22-rdf-syntax-ns#";
        private static final String XSD_NS = "http://www.w3.org/2001/XMLSchema#";

        private static final String DISTINCT_IRI = SPARQL_NS + "distinct";
        private static final String REDUCED_IRI = SPARQL_NS + "reduced";
        private static final String STAR_IRI = SPARQL_NS + "star";
        private static final String STR_IRI = SPARQL_NS + "str";
        private static final String LANG_IRI = SPARQL_NS + "lang";
        private static final String LANGMATCHES_IRI = SPARQL_NS + "langmatches";
        private static final String DATATYPE_IRI = SPARQL_NS + "datatype";
        private static final String BOUND_IRI = SPARQL_NS + "bound";
        private static final String SAMETERM_IRI = SPARQL_NS + "sameterm";
        private static final String ISIRI_IRI = SPARQL_NS + "isiri";
        private static final String ISURI_IRI = SPARQL_NS + "isuri";
        private static final String ISBLANK_IRI = SPARQL_NS + "isblank";
        private static final String ISLITERAL_IRI = SPARQL_NS + "isliteral";
        private static final String REGEX_IRI = SPARQL_NS + "regex";
        private static final String NIL_IRI = RDF_NS + "nil";
        private static final String TYPE_IRI = RDF_NS + "type";
        private static final String FIRST_IRI = RDF_NS + "first";
        private static final String REST_IRI = RDF_NS + "rest";
        private static final String BOOLEAN_IRI = XSD_NS + "boolean";
        private static final String DECIMAL_IRI = XSD_NS + "decimal";
        private static final String DOUBLE_IRI = XSD_NS + "double";
        private static final String NON_NEGATIVE_INTEGER_IRI = XSD_NS + "nonNegativeInteger";
        private static final String NON_POSITIVE_INTEGER_IRI = XSD_NS + "nonPositiveInteger";

        private static int blankNodeCounter = 0;
        private static int listCounter = 0;
        private static boolean star = false;

        private static Hashtable<String,String> listPrefix;
        private static HashSet<String> boundedVarList;
        private static HashSet<String> varList;

        public static void main( String[] args ) {
                //String[] args = {"testQuery" , "test.xml"};
                if (args.length != 2){
                        System.out.println("Usage : java -jar SPARQL-RDF.jar <query> <output>\n"+
                                "<query> : The name of the file containing the SPARQL query.\n"+
                                "<output> : The name of the file which will contain the RDF/XML representation of the SPARQL query.\n");
                        System.exit(0);
                }

                createXMLDocument();
                parseInputFile(args[0]);
                writeXMLDocument(args[1]);

        }

        public static String main( String input ) throws ParseException, TokenMgrError {
                createXMLDocument();
                parseInputStream(new StringBufferInputStream(input));
                return writeXMLDocument();
        }

        private static void parseInputStream(InputStream input) throws ParseException, TokenMgrError {
                // Parse input file and build the XML document
                Sparql parser = new Sparql(input);
                parser.Query();

                //parsing OK
                System.out.println("Syntax is okay.");
        }

        private static void createXMLDocument() {
                //intialise table of prefixes
                listPrefix = new Hashtable();
                boundedVarList = new HashSet();
                varList = new HashSet();
                try {
                        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
                        DocumentBuilder builder = factory.newDocumentBuilder();
                        document = builder.newDocument();
                }
                catch (FactoryConfigurationError e) {
                        System.out.println("DOM factory configuration problem: " + e.getMessage());
                        System.exit(1);
                }
                catch (ParserConfigurationException e) {
                        System.out.println("DOM parser configuration problem: " + e.getMessage());
                        System.exit(2);
                }
        }
        private static void parseInputFile(String filename) {
                try {
                        InputStream input = new FileInputStream(filename);
                        parseInputStream(input);
                }
                catch (FileNotFoundException e) {
                        System.out.println("Input file not found: " + e.getMessage());
                        System.exit(3);
                }
                catch (ParseException e) {
                        System.out.println("Syntax check failed: " + e.getMessage());
                        System.exit(4);
                }
                catch (TokenMgrError e) {
                        System.out.println("Syntax check failed: " + e.getMessage());
                        System.exit(4);
                }
        }
        private static String writeXMLDocument() {
                try {
                        //Configure transformer
                        TransformerFactory transfac = TransformerFactory.newInstance();
                        Transformer trans = transfac.newTransformer();
                        trans.setOutputProperty(OutputKeys.OMIT_XML_DECLARATION, "no");
                        trans.setOutputProperty(OutputKeys.INDENT, "yes");
                        trans.setOutputProperty(OutputKeys.METHOD, "xml");

                        //create string from XML tree
                        StringWriter sw = new StringWriter();
                        StreamResult result = new StreamResult(sw);
                        DOMSource source = new DOMSource(document);
                        trans.transform(source, result);
                        String xmlString = sw.toString();

                        return xmlString;
                }
                catch (TransformerFactoryConfigurationError e) {
                        System.out.println("Could not create the transformer factory: " + e.getMessage());
                        System.exit(6);
                }
                catch (TransformerConfigurationException e) {
                        System.out.println("Could not create a transformer: " + e.getMessage());
                        System.exit(7);
                }
                catch (TransformerException e) {
                        System.out.println("Could not transform document: " + e.getMessage());
                        System.exit(8);
                }
                return "";
        }
        private static void writeXMLDocument(String filename) {
                try {
                        FileOutputStream outputStream = new FileOutputStream(new File(filename));
                        //Configure transformer
                        TransformerFactory transfac = TransformerFactory.newInstance();
                        Transformer trans = transfac.newTransformer();
                        trans.setOutputProperty(OutputKeys.OMIT_XML_DECLARATION, "no");
                        trans.setOutputProperty(OutputKeys.INDENT, "yes");
                        trans.setOutputProperty(OutputKeys.METHOD, "xml");

                        //create string from XML tree
                        StringWriter sw = new StringWriter();
                        StreamResult result = new StreamResult(sw);
                        DOMSource source = new DOMSource(document);
                        trans.transform(source, result);
                        String xmlString = sw.toString();

                        //Output string in stream
                        outputStream.write(xmlString.getBytes());
                        outputStream.close();
                }
                catch (FileNotFoundException e) {
                        System.out.println("Output file not found: " + e.getMessage());
                        System.exit(5);
                }
                catch (TransformerFactoryConfigurationError e) {
                        System.out.println("Could not create the transformer factory: " + e.getMessage());
                        System.exit(6);
                }
                catch (TransformerConfigurationException e) {
                        System.out.println("Could not create a transformer: " + e.getMessage());
                        System.exit(7);
                }
                catch (TransformerException e) {
                        System.out.println("Could not transform document: " + e.getMessage());
                        System.exit(8);
                }
                catch (IOException e) {
                        System.out.println("Could not write in output file: " + e.getMessage());
                        System.exit(9);
                }
        }

  final public void Query() throws ParseException {
 Element root;
                root = document.createElement("rdf:RDF");
                root.setAttribute("xmlns:sparql", SPARQL_NS);
                root.setAttribute("xmlns:rdf", RDF_NS);
                listPrefix.put("sparql",SPARQL_NS);
                listPrefix.put("rdf",RDF_NS);
                document.appendChild(root);
    Prologue(root);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SELECT:
      SelectQuery(root);
      break;
    case CONSTRUCT:
      ConstructQuery(root);
      break;
    case DESCRIBE:
      DescribeQuery(root);
      break;
    case ASK:
      AskQuery(root);
      break;
    default:
      jj_la1[0] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(0);
                Iterator<String> it = varList.iterator();
        String varName;
        Element varElem, ref;
        while (it.hasNext()) {
            varName = it.next();
            if (!boundedVarList.contains(varName)) {
                varElem = document.createElement("sparql:Variable");
                varElem.setAttribute("sparql:varname", varName);
                root.appendChild(varElem);
                ref = document.createElement("sparql:ref");
                if (varName.startsWith("$")) {
                    ref.setAttribute("rdf:nodeID","_:vd"+varName.substring(1));
                }
                else {
                    ref.setAttribute("rdf:nodeID","_:vi"+varName.substring(1));
                }
                varElem.appendChild(ref);
            }
        }
  }

  final public void Prologue(Element root) throws ParseException {
 boolean hasBase;
                hasBase = false;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BASE:
      BaseDecl(root);
                         hasBase = true;
      break;
    default:
      jj_la1[1] = jj_gen;
      ;
    }
                if (!hasBase) {
                        listPrefix.put("","");
                }
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PREFIX:
        ;
        break;
      default:
        jj_la1[2] = jj_gen;
        break label_1;
      }
      PrefixDecl(root);
    }
  }

  final public void BaseDecl(Element root) throws ParseException {
 Token baseIRI;
    jj_consume_token(BASE);
    baseIRI = jj_consume_token(IRI_REF);
                String base = baseIRI.image.substring(1,baseIRI.image.length()-1);
                root.setAttribute("xmlns", base);
                listPrefix.put("",base);
  }

  final public void PrefixDecl(Element root) throws ParseException {
 Token prefixIRI, prefix;
    jj_consume_token(PREFIX);
    prefix = jj_consume_token(PNAME_NS);
    prefixIRI = jj_consume_token(IRI_REF);
                String pref = prefix.image.substring(0,prefix.image.length()-1);
                String prefIRI = prefixIRI.image.substring(1,prefixIRI.image.length()-1);
                root.setAttribute("xmlns:"+pref, prefIRI);
                listPrefix.put(pref,prefIRI);
  }

  final public void SelectQuery(Element root) throws ParseException {
 Element selectQuery, varSeq, select, selectmod; String varName;
    jj_consume_token(SELECT);
                selectQuery = document.createElement("sparql:SelectQuery");
                root.appendChild(selectQuery);
                select = document.createElement("sparql:select");
                selectQuery.appendChild(select);
                varSeq = document.createElement("sparql:VarSeq");
                select.appendChild(varSeq);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DISTINCT:
    case REDUCED:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DISTINCT:
        jj_consume_token(DISTINCT);
                selectmod = document.createElement("sparql:selectmod");
                selectmod.setAttribute("rdf:resource", DISTINCT_IRI);
                varSeq.appendChild(selectmod);
        break;
      case REDUCED:
        jj_consume_token(REDUCED);
                selectmod = document.createElement("sparql:selectmod");
                selectmod.setAttribute("rdf:resource", REDUCED_IRI);
                varSeq.appendChild(selectmod);
        break;
      default:
        jj_la1[3] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[4] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case VAR1:
    case VAR2:
      label_2:
      while (true) {
        varName = Var();
                Element li = document.createElement("rdf:li");
                varSeq.appendChild(li);
                Element var = document.createElement("sparql:Variable");
                li.appendChild(var);
                Element ref = document.createElement("sparql:ref");
                ref.setAttribute("rdf:nodeID", varName);
                var.appendChild(ref);
                if (varName.startsWith("_:vi")) {
                        varName = "?" + varName.substring(4);
                        var.setAttribute("sparql:varname",varName);
                        boundedVarList.add(varName);
                }
                else {
                        varName = "$" + varName.substring(4);
                        var.setAttribute("sparql:varname",varName);
                        boundedVarList.add(varName);
                }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case VAR1:
        case VAR2:
          ;
          break;
        default:
          jj_la1[5] = jj_gen;
          break label_2;
        }
      }
      break;
    case STAR:
      jj_consume_token(STAR);
                varSeq.setAttribute("rdf:about", STAR_IRI);
                star = true;
      break;
    default:
      jj_la1[6] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FROM:
        ;
        break;
      default:
        jj_la1[7] = jj_gen;
        break label_3;
      }
      DatasetClause(selectQuery);
    }
    WhereClause(selectQuery);
    SolutionModifier(selectQuery);
  }

  final public void ConstructQuery(Element root) throws ParseException {
 Element constructQuery;
    jj_consume_token(CONSTRUCT);
                constructQuery = document.createElement("sparql:ConstructQuery");
                root.appendChild(constructQuery);
    ConstructTemplate(constructQuery);
    label_4:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FROM:
        ;
        break;
      default:
        jj_la1[8] = jj_gen;
        break label_4;
      }
      DatasetClause(constructQuery);
    }
    WhereClause(constructQuery);
    SolutionModifier(constructQuery);
  }

  final public void DescribeQuery(Element root) throws ParseException {
 Element describeQuery, seq, describe, li; String varName;
    jj_consume_token(DESCRIBE);
                describeQuery = document.createElement("sparql:DescribeQuery");
                root.appendChild(describeQuery);
                describe = document.createElement("sparql:describe");
                describeQuery.appendChild(describe);
                seq = document.createElement("rdf:Seq");
                describe.appendChild(seq);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
    case VAR1:
    case VAR2:
                li = document.createElement("rdf:li");
      label_5:
      while (true) {
        VarOrIRIref(li);
                seq.appendChild(li);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IRI_REF:
        case PNAME_NS:
        case PNAME_LN:
        case VAR1:
        case VAR2:
          ;
          break;
        default:
          jj_la1[9] = jj_gen;
          break label_5;
        }
      }
      break;
    case STAR:
      jj_consume_token(STAR);
                seq.setAttribute("rdf:about", STAR_IRI);
                star = true;
      break;
    default:
      jj_la1[10] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    label_6:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FROM:
        ;
        break;
      default:
        jj_la1[11] = jj_gen;
        break label_6;
      }
      DatasetClause(describeQuery);
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case WHERE:
    case LBRACE:
      WhereClause(describeQuery);
      break;
    default:
      jj_la1[12] = jj_gen;
      ;
    }
    SolutionModifier(describeQuery);
  }

  final public void AskQuery(Element root) throws ParseException {
 Element askQuery;
    jj_consume_token(ASK);
                askQuery = document.createElement("sparql:AskQuery");
                root.appendChild(askQuery);
    label_7:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FROM:
        ;
        break;
      default:
        jj_la1[13] = jj_gen;
        break label_7;
      }
      DatasetClause(askQuery);
    }
    WhereClause(askQuery);
  }

  final public void DatasetClause(Element query) throws ParseException {
 String graphIRI; Element from, rdfgraph;
    jj_consume_token(FROM);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
      graphIRI = DefaultGraphClause();
                from = document.createElement("sparql:from");
                query.appendChild(from);
                rdfgraph = document.createElement("sparql:RDFGraph");
                from.appendChild(rdfgraph);
                rdfgraph.setAttribute("rdf:about", graphIRI);
      break;
    case NAMED:
      graphIRI = NamedGraphClause();
                from = document.createElement("sparql:fromnamed");
                query.appendChild(from);
                rdfgraph = document.createElement("sparql:RDFGraph");
                from.appendChild(rdfgraph);
                rdfgraph.setAttribute("rdf:about", graphIRI);
      break;
    default:
      jj_la1[14] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public String DefaultGraphClause() throws ParseException {
 String iri;
    iri = SourceSelector();
                                {if (true) return iri;}
    throw new Error("Missing return statement in function");
  }

  final public String NamedGraphClause() throws ParseException {
 String iri;
    jj_consume_token(NAMED);
    iri = SourceSelector();
                                        {if (true) return iri;}
    throw new Error("Missing return statement in function");
  }

  final public String SourceSelector() throws ParseException {
 String iri;
    iri = IRIref();
                        {if (true) return iri;}
    throw new Error("Missing return statement in function");
  }

  final public void WhereClause(Element query) throws ParseException {
 Element where, ggp;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case WHERE:
      jj_consume_token(WHERE);
      break;
    default:
      jj_la1[15] = jj_gen;
      ;
    }
                where = document.createElement("sparql:where");
                query.appendChild(where);
                ggp = document.createElement("sparql:GroupGraphPattern");
                where.appendChild(ggp);
    GroupGraphPattern(ggp);
  }

  final public void SolutionModifier(Element query) throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ORDER:
      OrderClause(query);
      break;
    default:
      jj_la1[16] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LIMIT:
    case OFFSET:
      LimitOffsetClauses(query);
      break;
    default:
      jj_la1[17] = jj_gen;
      ;
    }
  }

  final public void LimitOffsetClauses(Element query) throws ParseException {
 String limit = null; String offset = null; Element limitElem, offsetElem; Text t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LIMIT:
      limit = LimitClause();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OFFSET:
        offset = OffsetClause();
        break;
      default:
        jj_la1[18] = jj_gen;
        ;
      }
      break;
    case OFFSET:
      offset = OffsetClause();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LIMIT:
        limit = LimitClause();
        break;
      default:
        jj_la1[19] = jj_gen;
        ;
      }
      break;
    default:
      jj_la1[20] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                if (limit != null) {
                        limitElem = document.createElement("sparql:limit");
                        query.appendChild(limitElem);
                        limitElem.setAttribute("rdf:datatype",NON_NEGATIVE_INTEGER_IRI);
                        t = document.createTextNode(limit);
                        limitElem.appendChild(t);
                }
                if (offset != null) {
                        offsetElem = document.createElement("sparql:offset");
                        query.appendChild(offsetElem);
                        offsetElem.setAttribute("rdf:datatype",NON_NEGATIVE_INTEGER_IRI);
                        t = document.createTextNode(offset);
                        offsetElem.appendChild(t);
                }
  }

  final public void OrderClause(Element query) throws ParseException {
    jj_consume_token(ORDER);
    jj_consume_token(BY);
    label_8:
    while (true) {
      OrderCondition(query);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IRI_REF:
      case PNAME_NS:
      case PNAME_LN:
      case VAR1:
      case VAR2:
      case ASC:
      case DESC:
      case BOUND:
      case STR:
      case DTYPE:
      case LANG:
      case LANGMATCHES:
      case IS_URI:
      case IS_IRI:
      case IS_BLANK:
      case IS_LITERAL:
      case REGEX:
      case SAME_TERM:
      case LPAREN:
        ;
        break;
      default:
        jj_la1[21] = jj_gen;
        break label_8;
      }
    }
  }

  final public void OrderCondition(Element query) throws ParseException {
 Element orderby, expr; String varName;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ASC:
    case DESC:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASC:
        jj_consume_token(ASC);
                orderby = document.createElement("sparql:ascending");
        break;
      case DESC:
        jj_consume_token(DESC);
                orderby = document.createElement("sparql:descending");
        break;
      default:
        jj_la1[22] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      expr = BrackettedExpression();
                orderby.appendChild(expr);
      break;
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
    case VAR1:
    case VAR2:
    case BOUND:
    case STR:
    case DTYPE:
    case LANG:
    case LANGMATCHES:
    case IS_URI:
    case IS_IRI:
    case IS_BLANK:
    case IS_LITERAL:
    case REGEX:
    case SAME_TERM:
    case LPAREN:
                orderby = document.createElement("sparql:ascending");
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IRI_REF:
      case PNAME_NS:
      case PNAME_LN:
      case BOUND:
      case STR:
      case DTYPE:
      case LANG:
      case LANGMATCHES:
      case IS_URI:
      case IS_IRI:
      case IS_BLANK:
      case IS_LITERAL:
      case REGEX:
      case SAME_TERM:
      case LPAREN:
        Constraint(orderby);
        break;
      case VAR1:
      case VAR2:
        varName = Var();
                expr = document.createElement("sparql:PrimaryExpression");
                Element objectvalue = document.createElement("sparql:objectvalue");
                expr.appendChild(objectvalue);
                objectvalue.setAttribute("rdf:nodeId",varName);
                orderby.appendChild(expr);
        break;
      default:
        jj_la1[23] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[24] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                query.appendChild(orderby);
  }

  final public String LimitClause() throws ParseException {
 Token t;
    jj_consume_token(LIMIT);
    t = jj_consume_token(INTEGER);
                {if (true) return t.image;}
    throw new Error("Missing return statement in function");
  }

  final public String OffsetClause() throws ParseException {
 Token t;
    jj_consume_token(OFFSET);
    t = jj_consume_token(INTEGER);
                {if (true) return t.image;}
    throw new Error("Missing return statement in function");
  }

  final public void GroupGraphPattern(Element ggp) throws ParseException {
    jj_consume_token(LBRACE);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
    case BLANK_NODE_LABEL:
    case VAR1:
    case VAR2:
    case TRUE:
    case FALSE:
    case INTEGER:
    case DECIMAL:
    case DOUBLE:
    case INTEGER_POSITIVE:
    case DECIMAL_POSITIVE:
    case DOUBLE_POSITIVE:
    case INTEGER_NEGATIVE:
    case DECIMAL_NEGATIVE:
    case DOUBLE_NEGATIVE:
    case STRING_LITERAL1:
    case STRING_LITERAL2:
    case STRING_LITERAL_LONG1:
    case STRING_LITERAL_LONG2:
    case LPAREN:
    case NIL:
    case LBRACKET:
    case ANON:
      TriplesBlock(ggp);
      break;
    default:
      jj_la1[25] = jj_gen;
      ;
    }
    label_9:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case GRAPH:
      case OPTIONAL:
      case FILTER:
      case LBRACE:
        ;
        break;
      default:
        jj_la1[26] = jj_gen;
        break label_9;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case GRAPH:
      case OPTIONAL:
      case LBRACE:
        GraphPatternNotTriples(ggp);
        break;
      case FILTER:
        Filter(ggp);
        break;
      default:
        jj_la1[27] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DOT:
        jj_consume_token(DOT);
        break;
      default:
        jj_la1[28] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IRI_REF:
      case PNAME_NS:
      case PNAME_LN:
      case BLANK_NODE_LABEL:
      case VAR1:
      case VAR2:
      case TRUE:
      case FALSE:
      case INTEGER:
      case DECIMAL:
      case DOUBLE:
      case INTEGER_POSITIVE:
      case DECIMAL_POSITIVE:
      case DOUBLE_POSITIVE:
      case INTEGER_NEGATIVE:
      case DECIMAL_NEGATIVE:
      case DOUBLE_NEGATIVE:
      case STRING_LITERAL1:
      case STRING_LITERAL2:
      case STRING_LITERAL_LONG1:
      case STRING_LITERAL_LONG2:
      case LPAREN:
      case NIL:
      case LBRACKET:
      case ANON:
        TriplesBlock(ggp);
        break;
      default:
        jj_la1[29] = jj_gen;
        ;
      }
    }
    jj_consume_token(RBRACE);
  }

  final public void TriplesBlock(Element ggp) throws ParseException {
    TriplesSameSubject(ggp);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DOT:
      jj_consume_token(DOT);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IRI_REF:
      case PNAME_NS:
      case PNAME_LN:
      case BLANK_NODE_LABEL:
      case VAR1:
      case VAR2:
      case TRUE:
      case FALSE:
      case INTEGER:
      case DECIMAL:
      case DOUBLE:
      case INTEGER_POSITIVE:
      case DECIMAL_POSITIVE:
      case DOUBLE_POSITIVE:
      case INTEGER_NEGATIVE:
      case DECIMAL_NEGATIVE:
      case DOUBLE_NEGATIVE:
      case STRING_LITERAL1:
      case STRING_LITERAL2:
      case STRING_LITERAL_LONG1:
      case STRING_LITERAL_LONG2:
      case LPAREN:
      case NIL:
      case LBRACKET:
      case ANON:
        TriplesBlock(ggp);
        break;
      default:
        jj_la1[30] = jj_gen;
        ;
      }
      break;
    default:
      jj_la1[31] = jj_gen;
      ;
    }
  }

  final public void GraphPatternNotTriples(Element ggp) throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPTIONAL:
      OptionalGraphPattern(ggp);
      break;
    case LBRACE:
      GroupOrUnionGraphPattern(ggp);
      break;
    case GRAPH:
      GraphGraphPattern(ggp);
      break;
    default:
      jj_la1[32] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void OptionalGraphPattern(Element ggp) throws ParseException {
 Element li, ogp;
    jj_consume_token(OPTIONAL);
                li = document.createElement("rdf:li");
                ggp.appendChild(li);
                ogp = document.createElement("sparql:OptionalGraphPattern");
                li.appendChild(ogp);
    GroupGraphPattern(ogp);
  }

  final public void GraphGraphPattern(Element ggp) throws ParseException {
 Element li, graphgp, graphID;
    jj_consume_token(GRAPH);
                li = document.createElement("rdf:li");
                ggp.appendChild(li);
                graphgp = document.createElement("sparql:GraphGraphPattern");
                li.appendChild(graphgp);
                graphID = document.createElement("sparql:graphid");
    VarOrIRIref(graphID);
                graphgp.appendChild(graphID);
    GroupGraphPattern(graphgp);
  }

  final public void GroupOrUnionGraphPattern(Element ggp) throws ParseException {
 Element li, ggp2, ugp, union; boolean hasUnion;
                hasUnion = false;
                li = document.createElement("rdf:li");
                ggp.appendChild(li);
                ggp2 = document.createElement("sparql:GroupGraphPattern");
    GroupGraphPattern(ggp2);
    label_10:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case UNION:
        ;
        break;
      default:
        jj_la1[33] = jj_gen;
        break label_10;
      }
      jj_consume_token(UNION);
                hasUnion = true;
                ugp = document.createElement("sparql:UnionGraphPattern");
                li.appendChild(ugp);
                union = document.createElement("sparql:union");
                ugp.appendChild(union);
                union.appendChild(ggp2);
                union = document.createElement("sparql:union");
                ugp.appendChild(union);
                ggp2 = document.createElement("sparql:GroupGraphPattern");
                union.appendChild(ggp2);
      GroupGraphPattern(ggp2);
    }
                if (!hasUnion) li.appendChild(ggp2);
  }

  final public void Filter(Element ggp) throws ParseException {
 Element filter, constraint; String filterConstraint;
                filter = document.createElement("sparql:filter");
                ggp.appendChild(filter);
    jj_consume_token(FILTER);
    Constraint(filter);
  }

  final public void Constraint(Element filterOrOrder) throws ParseException {
 Element expression;
    if (jj_2_1(3)) {
      expression = BrackettedExpression();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BOUND:
      case STR:
      case DTYPE:
      case LANG:
      case LANGMATCHES:
      case IS_URI:
      case IS_IRI:
      case IS_BLANK:
      case IS_LITERAL:
      case REGEX:
      case SAME_TERM:
        expression = BuiltInCall();
        break;
      case IRI_REF:
      case PNAME_NS:
      case PNAME_LN:
        expression = FunctionCall();
        break;
      default:
        jj_la1[34] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
                filterOrOrder.appendChild(expression);
  }

  final public Element FunctionCall() throws ParseException {
 String iri; Element functionCall, call, args;
                functionCall = document.createElement("sparql:FunctionCall");
                call = document.createElement("sparql:call");
                functionCall.appendChild(call);
                args = document.createElement("sparql:args");
                functionCall.appendChild(args);
    iri = IRIref();
    ArgList(args);
                call.setAttribute("rdf:resource",iri);
                {if (true) return functionCall;}
    throw new Error("Missing return statement in function");
  }

  final public void ArgList(Element args) throws ParseException {
 Element expression;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NIL:
      jj_consume_token(NIL);
                args.setAttribute("rdf:resource",NIL_IRI);
      break;
    case LPAREN:
      jj_consume_token(LPAREN);
      expression = Expression();
                args.setAttribute("rdf:parseType","Collection");
                args.appendChild(expression);
      label_11:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[35] = jj_gen;
          break label_11;
        }
        jj_consume_token(COMMA);
        expression = Expression();
                args.appendChild(expression);
      }
      jj_consume_token(RPAREN);
      break;
    default:
      jj_la1[36] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void ConstructTemplate(Element constructQuery) throws ParseException {
 Element construct, ct;
    jj_consume_token(LBRACE);
                construct = document.createElement("sparql:construct");
                constructQuery.appendChild(construct);
                ct = document.createElement("sparql:TriplesGroup");
                construct.appendChild(ct);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
    case BLANK_NODE_LABEL:
    case VAR1:
    case VAR2:
    case TRUE:
    case FALSE:
    case INTEGER:
    case DECIMAL:
    case DOUBLE:
    case INTEGER_POSITIVE:
    case DECIMAL_POSITIVE:
    case DOUBLE_POSITIVE:
    case INTEGER_NEGATIVE:
    case DECIMAL_NEGATIVE:
    case DOUBLE_NEGATIVE:
    case STRING_LITERAL1:
    case STRING_LITERAL2:
    case STRING_LITERAL_LONG1:
    case STRING_LITERAL_LONG2:
    case LPAREN:
    case NIL:
    case LBRACKET:
    case ANON:
      ConstructTriples(ct);
      break;
    default:
      jj_la1[37] = jj_gen;
      ;
    }
    jj_consume_token(RBRACE);
  }

  final public void ConstructTriples(Element ct) throws ParseException {
    TriplesSameSubject(ct);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DOT:
      jj_consume_token(DOT);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IRI_REF:
      case PNAME_NS:
      case PNAME_LN:
      case BLANK_NODE_LABEL:
      case VAR1:
      case VAR2:
      case TRUE:
      case FALSE:
      case INTEGER:
      case DECIMAL:
      case DOUBLE:
      case INTEGER_POSITIVE:
      case DECIMAL_POSITIVE:
      case DOUBLE_POSITIVE:
      case INTEGER_NEGATIVE:
      case DECIMAL_NEGATIVE:
      case DOUBLE_NEGATIVE:
      case STRING_LITERAL1:
      case STRING_LITERAL2:
      case STRING_LITERAL_LONG1:
      case STRING_LITERAL_LONG2:
      case LPAREN:
      case NIL:
      case LBRACKET:
      case ANON:
        ConstructTriples(ct);
        break;
      default:
        jj_la1[38] = jj_gen;
        ;
      }
      break;
    default:
      jj_la1[39] = jj_gen;
      ;
    }
  }

  final public void TriplesSameSubject(Element ggp) throws ParseException {
 Element subjectModel; SubjectOrObject elemModel;
                elemModel = new SubjectOrObject(document);
                subjectModel = elemModel.getSubject();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
    case BLANK_NODE_LABEL:
    case VAR1:
    case VAR2:
    case TRUE:
    case FALSE:
    case INTEGER:
    case DECIMAL:
    case DOUBLE:
    case INTEGER_POSITIVE:
    case DECIMAL_POSITIVE:
    case DOUBLE_POSITIVE:
    case INTEGER_NEGATIVE:
    case DECIMAL_NEGATIVE:
    case DOUBLE_NEGATIVE:
    case STRING_LITERAL1:
    case STRING_LITERAL2:
    case STRING_LITERAL_LONG1:
    case STRING_LITERAL_LONG2:
    case NIL:
    case ANON:
      VarOrTerm(elemModel);
      PropertyListNotEmpty(ggp, subjectModel);
      break;
    case LPAREN:
    case LBRACKET:
      TriplesNode(ggp, elemModel);
      PropertyList(ggp, subjectModel);
      break;
    default:
      jj_la1[40] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void PropertyListNotEmpty(Element ggp, Element subjectModel) throws ParseException {
 Element predicateModel;
                predicateModel = document.createElement("rdf:predicate");
    Verb(predicateModel);
    ObjectList(ggp, subjectModel, predicateModel);
    label_12:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEMICOLON:
        ;
        break;
      default:
        jj_la1[41] = jj_gen;
        break label_12;
      }
      jj_consume_token(SEMICOLON);
                predicateModel = document.createElement("rdf:predicate");
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IRI_REF:
      case PNAME_NS:
      case PNAME_LN:
      case VAR1:
      case VAR2:
      case KW_A:
        Verb(predicateModel);
        ObjectList(ggp, subjectModel, predicateModel);
        break;
      default:
        jj_la1[42] = jj_gen;
        ;
      }
    }
  }

  final public void PropertyList(Element ggp, Element subjectModel) throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
    case VAR1:
    case VAR2:
    case KW_A:
      PropertyListNotEmpty(ggp, subjectModel);
      break;
    default:
      jj_la1[43] = jj_gen;
      ;
    }
  }

  final public void ObjectList(Element ggp, Element subjectModel, Element predicateModel) throws ParseException {
    Object(ggp, subjectModel, predicateModel);
    label_13:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[44] = jj_gen;
        break label_13;
      }
      jj_consume_token(COMMA);
      Object(ggp, subjectModel, predicateModel);
    }
  }

  final public void Object(Element ggp, Element subjectModel, Element predicateModel) throws ParseException {
 Element li, statement, subject, predicate, object; SubjectOrObject elem;
                li = document.createElement("rdf:li");
                ggp.appendChild(li);
                statement = document.createElement("sparql:Statement");
                li.appendChild(statement);
                subject = (Element) subjectModel.cloneNode(true);
                statement.appendChild(subject);
                predicate = (Element) predicateModel.cloneNode(true);
                statement.appendChild(predicate);
                elem = new SubjectOrObject(document);
    GraphNode(ggp, elem);
                object = elem.getObject();
                statement.appendChild(object);
  }

  final public void Verb(Element predicateModel) throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
    case VAR1:
    case VAR2:
      VarOrIRIref(predicateModel);
      break;
    case KW_A:
      jj_consume_token(KW_A);
                                               predicateModel.setAttribute("rdf:resource",TYPE_IRI);
      break;
    default:
      jj_la1[45] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void TriplesNode(Element ggp, SubjectOrObject elem) throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAREN:
                elem.setAttribute("rdf:nodeID","_:l" + listCounter);
                listCounter ++;
      Collection(ggp, elem);
      break;
    case LBRACKET:
                elem.setAttribute("rdf:nodeID","_:a" + blankNodeCounter);
                blankNodeCounter ++;
      BlankNodePropertyList(ggp, elem.getSubject());
      break;
    default:
      jj_la1[46] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void BlankNodePropertyList(Element ggp, Element subjectModel) throws ParseException {
    jj_consume_token(LBRACKET);
    PropertyListNotEmpty(ggp, subjectModel);
    jj_consume_token(RBRACKET);
  }

  final public void Collection(Element ggp, SubjectOrObject list) throws ParseException {
 SubjectOrObject elem, tlist; Element li, stmt, subject, predicate;
    jj_consume_token(LPAREN);
                elem = new SubjectOrObject(document);
                tlist = list.cloneNode();
    label_14:
    while (true) {
      GraphNode(ggp, elem);
                li = document.createElement("rdf:li");
                ggp.appendChild(li);
                stmt = document.createElement("rdf:Statement");
                li.appendChild(stmt);
                subject = (Element) tlist.getSubject().cloneNode(true);
                stmt.appendChild(subject);
                predicate = document.createElement("rdf:predicate");
                predicate.setAttribute("rdf:resource", FIRST_IRI);
                stmt.appendChild(predicate);
                stmt.appendChild(elem.getObject());
                li = document.createElement("rdf:li");
                ggp.appendChild(li);
                stmt = document.createElement("rdf:Statement");
                li.appendChild(stmt);
                subject = (Element) tlist.getSubject().cloneNode(true);
                stmt.appendChild(subject);
                predicate = document.createElement("rdf:predicate");
                predicate.setAttribute("rdf:resource", REST_IRI);
                stmt.appendChild(predicate);
                tlist = new SubjectOrObject(document);
                tlist.setAttribute("rdf:nodeID", "_:l"+listCounter);
                listCounter ++;
                stmt.appendChild(tlist.getObject());
                elem = new SubjectOrObject(document);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IRI_REF:
      case PNAME_NS:
      case PNAME_LN:
      case BLANK_NODE_LABEL:
      case VAR1:
      case VAR2:
      case TRUE:
      case FALSE:
      case INTEGER:
      case DECIMAL:
      case DOUBLE:
      case INTEGER_POSITIVE:
      case DECIMAL_POSITIVE:
      case DOUBLE_POSITIVE:
      case INTEGER_NEGATIVE:
      case DECIMAL_NEGATIVE:
      case DOUBLE_NEGATIVE:
      case STRING_LITERAL1:
      case STRING_LITERAL2:
      case STRING_LITERAL_LONG1:
      case STRING_LITERAL_LONG2:
      case LPAREN:
      case NIL:
      case LBRACKET:
      case ANON:
        ;
        break;
      default:
        jj_la1[47] = jj_gen;
        break label_14;
      }
    }
                tlist.getObject().removeAttribute("rdf:nodeID");
                tlist.getObject().setAttribute("rdf:resource", NIL_IRI);
    jj_consume_token(RPAREN);
  }

  final public void GraphNode(Element ggp, SubjectOrObject elem) throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
    case BLANK_NODE_LABEL:
    case VAR1:
    case VAR2:
    case TRUE:
    case FALSE:
    case INTEGER:
    case DECIMAL:
    case DOUBLE:
    case INTEGER_POSITIVE:
    case DECIMAL_POSITIVE:
    case DOUBLE_POSITIVE:
    case INTEGER_NEGATIVE:
    case DECIMAL_NEGATIVE:
    case DOUBLE_NEGATIVE:
    case STRING_LITERAL1:
    case STRING_LITERAL2:
    case STRING_LITERAL_LONG1:
    case STRING_LITERAL_LONG2:
    case NIL:
    case ANON:
      VarOrTerm(elem);
      break;
    case LPAREN:
    case LBRACKET:
      TriplesNode(ggp, elem);
      break;
    default:
      jj_la1[48] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void VarOrTerm(SubjectOrObject elem) throws ParseException {
 String varName;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case VAR1:
    case VAR2:
      varName = Var();
                elem.setAttribute("rdf:nodeID", varName);
      break;
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
    case BLANK_NODE_LABEL:
    case TRUE:
    case FALSE:
    case INTEGER:
    case DECIMAL:
    case DOUBLE:
    case INTEGER_POSITIVE:
    case DECIMAL_POSITIVE:
    case DOUBLE_POSITIVE:
    case INTEGER_NEGATIVE:
    case DECIMAL_NEGATIVE:
    case DOUBLE_NEGATIVE:
    case STRING_LITERAL1:
    case STRING_LITERAL2:
    case STRING_LITERAL_LONG1:
    case STRING_LITERAL_LONG2:
    case NIL:
    case ANON:
      GraphTerm(elem);
      break;
    default:
      jj_la1[49] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void VarOrIRIref(Element elem) throws ParseException {
 String str;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case VAR1:
    case VAR2:
      str = Var();
                if (elem.getNodeName().equals("rdf:li")) {
                        Element var = document.createElement("sparql:Variable");
                        elem.appendChild(var);
                        Element ref = document.createElement("sparql:ref");
                        ref.setAttribute("rdf:nodeID", str);
                        var.appendChild(ref);
                        if (str.startsWith("_:vi")) {
                                str = "?" + str.substring(4);
                                var.setAttribute("sparql:varname",str);
                                boundedVarList.add(str);
                        }
                        else {
                                str = "$" + str.substring(4);
                                var.setAttribute("sparql:varname",str);
                                boundedVarList.add(str);
                        }
                }
                else {
                        elem.setAttribute("rdf:nodeID", str);
                }
      break;
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
      str = IRIref();
                elem.setAttribute("rdf:resource", str);
      break;
    default:
      jj_la1[50] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public String Var() throws ParseException {
 Token var;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case VAR1:
      var = jj_consume_token(VAR1);
                varList.add(var.image);
                {if (true) return "_:vi" + var.image.substring(1);}
      break;
    case VAR2:
      var = jj_consume_token(VAR2);
                varList.add(var.image);
                {if (true) return "_:vd" + var.image.substring(1);}
      break;
    default:
      jj_la1[51] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public void GraphTerm(SubjectOrObject elem) throws ParseException {
 String str;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
      str = IRIref();
                elem.setAttribute("rdf:resource", str);
      break;
    case STRING_LITERAL1:
    case STRING_LITERAL2:
    case STRING_LITERAL_LONG1:
    case STRING_LITERAL_LONG2:
      RDFLiteral(elem);
      break;
    case INTEGER:
    case DECIMAL:
    case DOUBLE:
    case INTEGER_POSITIVE:
    case DECIMAL_POSITIVE:
    case DOUBLE_POSITIVE:
    case INTEGER_NEGATIVE:
    case DECIMAL_NEGATIVE:
    case DOUBLE_NEGATIVE:
      NumericLiteral(elem);
      break;
    case TRUE:
    case FALSE:
      str = BooleanLiteral();
                Text literal = document.createTextNode(str);
                elem.appendChild(literal);
                elem.setAttribute("rdf:datatype", BOOLEAN_IRI);
      break;
    case BLANK_NODE_LABEL:
    case ANON:
      str = BlankNode();
                elem.setAttribute("rdf:nodeID", str);
      break;
    case NIL:
      jj_consume_token(NIL);
                elem.setAttribute("rdf:resource", NIL_IRI);
      break;
    default:
      jj_la1[52] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public Element Expression() throws ParseException {
 Element expression;
    expression = ConditionalOrExpression();
                {if (true) return expression;}
    throw new Error("Missing return statement in function");
  }

  final public Element ConditionalOrExpression() throws ParseException {
 Element expr, expr2, result = null, left, right = null; boolean rel = false;
    expr = ConditionalAndExpression();
    label_15:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SC_OR:
        ;
        break;
      default:
        jj_la1[53] = jj_gen;
        break label_15;
      }
      jj_consume_token(SC_OR);
      expr2 = ConditionalAndExpression();
                Element expression = document.createElement("sparql:ConditionalOrExpression");
                if (!rel) {
                        rel = true;
                        result = expression;
                }
                else {
                        right.appendChild(expression);
                }
                left = document.createElement("sparql:or_left");
                expression.appendChild(left);
                right = document.createElement("sparql:or_right");
                expression.appendChild(right);
                left.appendChild(expr);
                expr = expr2;
    }
                if (rel) {
                        right.appendChild(expr);
                        {if (true) return result;}
                }
                {if (true) return expr;}
    throw new Error("Missing return statement in function");
  }

  final public Element ConditionalAndExpression() throws ParseException {
 Element expr, expr2, result = null, left, right = null; boolean rel = false;
    expr = ValueLogical();
    label_16:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SC_AND:
        ;
        break;
      default:
        jj_la1[54] = jj_gen;
        break label_16;
      }
      jj_consume_token(SC_AND);
      expr2 = ValueLogical();
                Element expression = document.createElement("sparql:ConditionalAndExpression");
                if (!rel) {
                        rel = true;
                        result = expression;
                }
                else {
                        right.appendChild(expression);
                }
                left = document.createElement("sparql:and_left");
                expression.appendChild(left);
                right = document.createElement("sparql:and_right");
                expression.appendChild(right);
                left.appendChild(expr);
                expr = expr2;
    }
                if (rel) {
                        right.appendChild(expr);
                        {if (true) return result;}
                }
                {if (true) return expr;}
    throw new Error("Missing return statement in function");
  }

  final public Element ValueLogical() throws ParseException {
 Element result;
    result = RelationalExpression();
                {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final public Element RelationalExpression() throws ParseException {
 Element expr, expr2, result, left, right, relElem;
    expr = NumericExpression();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EQ:
    case NE:
    case GT:
    case LT:
    case LE:
    case GE:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EQ:
        jj_consume_token(EQ);
        expr2 = NumericExpression();
                relElem = document.createElement("sparql:RelationExpression");
                left = document.createElement("sparql:eq_left");
                relElem.appendChild(left);
                left.appendChild(expr);
                right = document.createElement("sparql:eq_right");
                relElem.appendChild(right);
                right.appendChild(expr2);
                expr = relElem;
        break;
      case NE:
        jj_consume_token(NE);
        expr2 = NumericExpression();
                relElem = document.createElement("sparql:RelationExpression");
                left = document.createElement("sparql:neq_left");
                relElem.appendChild(left);
                left.appendChild(expr);
                right = document.createElement("sparql:neq_right");
                relElem.appendChild(right);
                right.appendChild(expr2);
                expr = relElem;
        break;
      case LT:
        jj_consume_token(LT);
        expr2 = NumericExpression();
                relElem = document.createElement("sparql:RelationExpression");
                left = document.createElement("sparql:lt_left");
                relElem.appendChild(left);
                left.appendChild(expr);
                right = document.createElement("sparql:lt_right");
                relElem.appendChild(right);
                right.appendChild(expr2);
                expr = relElem;
        break;
      case GT:
        jj_consume_token(GT);
        expr2 = NumericExpression();
                relElem = document.createElement("sparql:RelationExpression");
                left = document.createElement("sparql:gt_left");
                relElem.appendChild(left);
                left.appendChild(expr);
                right = document.createElement("sparql:gt_right");
                relElem.appendChild(right);
                right.appendChild(expr2);
                expr = relElem;
        break;
      case LE:
        jj_consume_token(LE);
        expr2 = NumericExpression();
                relElem = document.createElement("sparql:RelationExpression");
                left = document.createElement("sparql:leq_left");
                relElem.appendChild(left);
                left.appendChild(expr);
                right = document.createElement("sparql:leq_right");
                relElem.appendChild(right);
                right.appendChild(expr2);
                expr = relElem;
        break;
      case GE:
        jj_consume_token(GE);
        expr2 = NumericExpression();
                relElem = document.createElement("sparql:RelationExpression");
                left = document.createElement("sparql:geq_left");
                relElem.appendChild(left);
                left.appendChild(expr);
                right = document.createElement("sparql:geq_right");
                relElem.appendChild(right);
                right.appendChild(expr2);
                expr = relElem;
        break;
      default:
        jj_la1[55] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[56] = jj_gen;
      ;
    }
                {if (true) return expr;}
    throw new Error("Missing return statement in function");
  }

  final public Element NumericExpression() throws ParseException {
 Element result;
    result = AdditiveExpression();
                {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final public Element AdditiveExpression() throws ParseException {
 Element expr, expr2, expression, result = null, left, right = null; boolean rel = false; SubjectOrObject elem;
    expr = MultiplicativeExpression();
    label_17:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INTEGER_POSITIVE:
      case DECIMAL_POSITIVE:
      case DOUBLE_POSITIVE:
      case INTEGER_NEGATIVE:
      case DECIMAL_NEGATIVE:
      case DOUBLE_NEGATIVE:
      case PLUS:
      case MINUS:
        ;
        break;
      default:
        jj_la1[57] = jj_gen;
        break label_17;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
        jj_consume_token(PLUS);
        expr2 = MultiplicativeExpression();
                expression = document.createElement("sparql:AdditiveExpression");
                if (!rel) {
                        rel = true;
                        result = expression;
                }
                else {
                        right.appendChild(expression);
                }
                left = document.createElement("sparql:plus_left");
                expression.appendChild(left);
                right = document.createElement("sparql:plus_right");
                expression.appendChild(right);
                left.appendChild(expr);
                expr = expr2;
        break;
      case MINUS:
        jj_consume_token(MINUS);
        expr2 = MultiplicativeExpression();
                expression = document.createElement("sparql:AdditiveExpression");
                if (!rel) {
                        rel = true;
                        result = expression;
                }
                else {
                        right.appendChild(expression);
                }
                left = document.createElement("sparql:minus_left");
                expression.appendChild(left);
                right = document.createElement("sparql:minus_right");
                expression.appendChild(right);
                left.appendChild(expr);
                expr = expr2;
        break;
      case INTEGER_POSITIVE:
      case DECIMAL_POSITIVE:
      case DOUBLE_POSITIVE:
                elem = new SubjectOrObject(document);
        NumericLiteralPositive(elem);
                expr2 = document.createElement("sparql:PrimaryExpression");
                expr2.appendChild(elem.getLiteralValue());
                expression = document.createElement("sparql:AdditiveExpression");
                if (!rel) {
                        rel = true;
                        result = expression;
                }
                else {
                        right.appendChild(expression);
                }
                left = document.createElement("sparql:plus_left");
                expression.appendChild(left);
                right = document.createElement("sparql:plus_right");
                expression.appendChild(right);
                left.appendChild(expr);
                expr = expr2;
        break;
      case INTEGER_NEGATIVE:
      case DECIMAL_NEGATIVE:
      case DOUBLE_NEGATIVE:
                elem = new SubjectOrObject(document);
        NumericLiteralNegative(elem);
                expr2 = document.createElement("sparql:PrimaryExpression");
                expr2.appendChild(elem.getLiteralValue());
                expression = document.createElement("sparql:AdditiveExpression");
                if (!rel) {
                        rel = true;
                        result = expression;
                }
                else {
                        right.appendChild(expression);
                }
                left = document.createElement("sparql:plus_left");
                expression.appendChild(left);
                right = document.createElement("sparql:plus_right");
                expression.appendChild(right);
                left.appendChild(expr);
                expr = expr2;
        break;
      default:
        jj_la1[58] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
                if (rel) {
                        right.appendChild(expr);
                        {if (true) return result;}
                }
                {if (true) return expr;}
    throw new Error("Missing return statement in function");
  }

  final public Element MultiplicativeExpression() throws ParseException {
 Element expr, expr2, expression, result = null, left, right = null; boolean rel = false;
    expr = UnaryExpression();
    label_18:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STAR:
      case SLASH:
        ;
        break;
      default:
        jj_la1[59] = jj_gen;
        break label_18;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STAR:
        jj_consume_token(STAR);
        expr2 = UnaryExpression();
                expression = document.createElement("sparql:MultiplicativeExpression");
                if (!rel) {
                        rel = true;
                        result = expression;
                }
                else {
                        right.appendChild(expression);
                }
                left = document.createElement("sparql:multiply_left");
                expression.appendChild(left);
                right = document.createElement("sparql:multiply_right");
                expression.appendChild(right);
                left.appendChild(expr);
                expr = expr2;
        break;
      case SLASH:
        jj_consume_token(SLASH);
        expr2 = UnaryExpression();
                expression = document.createElement("sparql:MultiplicativeExpression");
                if (!rel) {
                        rel = true;
                        result = expression;
                }
                else {
                        right.appendChild(expression);
                }
                left = document.createElement("sparql:divide_left");
                expression.appendChild(left);
                right = document.createElement("sparql:divide_right");
                expression.appendChild(right);
                left.appendChild(expr);
                expr = expr2;
        break;
      default:
        jj_la1[60] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
                if (rel) {
                        right.appendChild(expr);
                        {if (true) return result;}
                }
                {if (true) return expr;}
    throw new Error("Missing return statement in function");
  }

  final public Element UnaryExpression() throws ParseException {
 Element expr, expression, op;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BANG:
      jj_consume_token(BANG);
      expr = PrimaryExpression();
                expression = document.createElement("sparql:UnaryExpression");
                op = document.createElement("sparql:negation");
                expression.appendChild(op);
                op.appendChild(expr);
                expr = expression;
      break;
    case PLUS:
      jj_consume_token(PLUS);
      expr = PrimaryExpression();
                expression = document.createElement("sparql:UnaryExpression");
                op = document.createElement("sparql:unaryplus");
                expression.appendChild(op);
                op.appendChild(expr);
                expr = expression;
      break;
    case MINUS:
      jj_consume_token(MINUS);
      expr = PrimaryExpression();
                expression = document.createElement("sparql:UnaryExpression");
                op = document.createElement("sparql:unaryminus");
                expression.appendChild(op);
                op.appendChild(expr);
                expr = expression;
      break;
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
    case VAR1:
    case VAR2:
    case BOUND:
    case STR:
    case DTYPE:
    case LANG:
    case LANGMATCHES:
    case IS_URI:
    case IS_IRI:
    case IS_BLANK:
    case IS_LITERAL:
    case REGEX:
    case SAME_TERM:
    case TRUE:
    case FALSE:
    case INTEGER:
    case DECIMAL:
    case DOUBLE:
    case INTEGER_POSITIVE:
    case DECIMAL_POSITIVE:
    case DOUBLE_POSITIVE:
    case INTEGER_NEGATIVE:
    case DECIMAL_NEGATIVE:
    case DOUBLE_NEGATIVE:
    case STRING_LITERAL1:
    case STRING_LITERAL2:
    case STRING_LITERAL_LONG1:
    case STRING_LITERAL_LONG2:
    case LPAREN:
      expr = PrimaryExpression();
      break;
    default:
      jj_la1[61] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return expr;}
    throw new Error("Missing return statement in function");
  }

  final public Element PrimaryExpression() throws ParseException {
 Element expr; String str; SubjectOrObject elem;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAREN:
      expr = BrackettedExpression();
      break;
    case BOUND:
    case STR:
    case DTYPE:
    case LANG:
    case LANGMATCHES:
    case IS_URI:
    case IS_IRI:
    case IS_BLANK:
    case IS_LITERAL:
    case REGEX:
    case SAME_TERM:
      expr = BuiltInCall();
      break;
    case IRI_REF:
    case PNAME_NS:
    case PNAME_LN:
      expr = IRIrefOrFunction();
      break;
    case STRING_LITERAL1:
    case STRING_LITERAL2:
    case STRING_LITERAL_LONG1:
    case STRING_LITERAL_LONG2:
                elem = new SubjectOrObject(document);
                expr = document.createElement("sparql:PrimaryExpression");
                expr.appendChild(elem.getLiteralValue());
      RDFLiteral(elem);
      break;
    case INTEGER:
    case DECIMAL:
    case DOUBLE:
    case INTEGER_POSITIVE:
    case DECIMAL_POSITIVE:
    case DOUBLE_POSITIVE:
    case INTEGER_NEGATIVE:
    case DECIMAL_NEGATIVE:
    case DOUBLE_NEGATIVE:
                elem = new SubjectOrObject(document);
                expr = document.createElement("sparql:PrimaryExpression");
                expr.appendChild(elem.getLiteralValue());
      NumericLiteral(elem);
      break;
    case TRUE:
    case FALSE:
      str = BooleanLiteral();
                expr = document.createElement("sparql:PrimaryExpression");
                Element literalvalue = document.createElement("sparql:literalvalue");
                expr.appendChild(literalvalue);
                Text literal = document.createTextNode(str);
                literalvalue.appendChild(literal);
                literalvalue.setAttribute("rdf:datatype", BOOLEAN_IRI);
      break;
    case VAR1:
    case VAR2:
      str = Var();
                expr = document.createElement("sparql:PrimaryExpression");
                Element objectvalue = document.createElement("sparql:objectvalue");
                expr.appendChild(objectvalue);
                objectvalue.setAttribute("rdf:nodeID",str);
      break;
    default:
      jj_la1[62] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return expr;}
    throw new Error("Missing return statement in function");
  }

  final public Element BrackettedExpression() throws ParseException {
 Element expr;
    jj_consume_token(LPAREN);
    expr = Expression();
    jj_consume_token(RPAREN);
                Element bracketExpr = document.createElement("sparql:BrackettedExpression");
                Element inbracket = document.createElement("sparql:inbracket");
                bracketExpr.appendChild(inbracket);
                inbracket.appendChild(expr);
                {if (true) return bracketExpr;}
    throw new Error("Missing return statement in function");
  }

  final public Element BuiltInCall() throws ParseException {
 Element expr, expr1, expr2, call, args; String varName;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STR:
      jj_consume_token(STR);
      jj_consume_token(LPAREN);
      expr1 = Expression();
      jj_consume_token(RPAREN);
                expr = document.createElement("sparql:BuiltInCall");
                call = document.createElement("sparql:call");
                args = document.createElement("sparql:args");
                expr.appendChild(call);
                expr.appendChild(args);
                call.setAttribute("rdf:resource",STR_IRI);
                args.setAttribute("rdf:parseType","Collection");
                args.appendChild(expr1);
      break;
    case LANG:
      jj_consume_token(LANG);
      jj_consume_token(LPAREN);
      expr1 = Expression();
      jj_consume_token(RPAREN);
                expr = document.createElement("sparql:BuiltInCall");
                call = document.createElement("sparql:call");
                args = document.createElement("sparql:args");
                expr.appendChild(call);
                expr.appendChild(args);
                call.setAttribute("rdf:resource",LANG_IRI);
                args.setAttribute("rdf:parseType","Collection");
                args.appendChild(expr1);
      break;
    case LANGMATCHES:
      jj_consume_token(LANGMATCHES);
      jj_consume_token(LPAREN);
      expr1 = Expression();
      jj_consume_token(COMMA);
      expr2 = Expression();
      jj_consume_token(RPAREN);
                expr = document.createElement("sparql:BuiltInCall");
                call = document.createElement("sparql:call");
                args = document.createElement("sparql:args");
                expr.appendChild(call);
                expr.appendChild(args);
                call.setAttribute("rdf:resource",LANGMATCHES_IRI);
                args.setAttribute("rdf:parseType","Collection");
                args.appendChild(expr1);
                args.appendChild(expr2);
      break;
    case DTYPE:
      jj_consume_token(DTYPE);
      jj_consume_token(LPAREN);
      expr1 = Expression();
      jj_consume_token(RPAREN);
                expr = document.createElement("sparql:BuiltInCall");
                call = document.createElement("sparql:call");
                args = document.createElement("sparql:args");
                expr.appendChild(call);
                expr.appendChild(args);
                call.setAttribute("rdf:resource",DATATYPE_IRI);
                args.setAttribute("rdf:parseType","Collection");
                args.appendChild(expr1);
      break;
    case BOUND:
      jj_consume_token(BOUND);
      jj_consume_token(LPAREN);
      varName = Var();
      jj_consume_token(RPAREN);
                expr1 = document.createElement("sparql:PrimaryExpression");
                Element objectvalue = document.createElement("sparql:objectvalue");
                expr1.appendChild(objectvalue);
                objectvalue.setAttribute("rdf:nodeId",varName);
                expr = document.createElement("sparql:BuiltInCall");
                call = document.createElement("sparql:call");
                args = document.createElement("sparql:args");
                expr.appendChild(call);
                expr.appendChild(args);
                call.setAttribute("rdf:resource",BOUND_IRI);
                args.setAttribute("rdf:parseType","Collection");
                args.appendChild(expr1);
      break;
    case SAME_TERM:
      jj_consume_token(SAME_TERM);
      jj_consume_token(LPAREN);
      expr1 = Expression();
      jj_consume_token(COMMA);
      expr2 = Expression();
      jj_consume_token(RPAREN);
                expr = document.createElement("sparql:BuiltInCall");
                call = document.createElement("sparql:call");
                args = document.createElement("sparql:args");
                expr.appendChild(call);
                expr.appendChild(args);
                call.setAttribute("rdf:resource",SAMETERM_IRI);
                args.setAttribute("rdf:parseType","Collection");
                args.appendChild(expr1);
                args.appendChild(expr2);
      break;
    case IS_IRI:
      jj_consume_token(IS_IRI);
      jj_consume_token(LPAREN);
      expr1 = Expression();
      jj_consume_token(RPAREN);
                expr = document.createElement("sparql:BuiltInCall");
                call = document.createElement("sparql:call");
                args = document.createElement("sparql:args");
                expr.appendChild(call);
                expr.appendChild(args);
                call.setAttribute("rdf:resource",ISIRI_IRI);
                args.setAttribute("rdf:parseType","Collection");
                args.appendChild(expr1);
      break;
    case IS_URI:
      jj_consume_token(IS_URI);
      jj_consume_token(LPAREN);
      expr1 = Expression();
      jj_consume_token(RPAREN);
                expr = document.createElement("sparql:BuiltInCall");
                call = document.createElement("sparql:call");
                args = document.createElement("sparql:args");
                expr.appendChild(call);
                expr.appendChild(args);
                call.setAttribute("rdf:resource",ISURI_IRI);
                args.setAttribute("rdf:parseType","Collection");
                args.appendChild(expr1);
      break;
    case IS_BLANK:
      jj_consume_token(IS_BLANK);
      jj_consume_token(LPAREN);
      expr1 = Expression();
      jj_consume_token(RPAREN);
                expr = document.createElement("sparql:BuiltInCall");
                call = document.createElement("sparql:call");
                args = document.createElement("sparql:args");
                expr.appendChild(call);
                expr.appendChild(args);
                call.setAttribute("rdf:resource",ISBLANK_IRI);
                args.setAttribute("rdf:parseType","Collection");
                args.appendChild(expr1);
      break;
    case IS_LITERAL:
      jj_consume_token(IS_LITERAL);
      jj_consume_token(LPAREN);
      expr1 = Expression();
      jj_consume_token(RPAREN);
                expr = document.createElement("sparql:BuiltInCall");
                call = document.createElement("sparql:call");
                args = document.createElement("sparql:args");
                expr.appendChild(call);
                expr.appendChild(args);
                call.setAttribute("rdf:resource",ISLITERAL_IRI);
                args.setAttribute("rdf:parseType","Collection");
                args.appendChild(expr1);
      break;
    case REGEX:
      expr = RegexExpression();
      break;
    default:
      jj_la1[63] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return expr;}
    throw new Error("Missing return statement in function");
  }

  final public Element RegexExpression() throws ParseException {
 Element expr1, expr2, expr3, regexpr;
    jj_consume_token(REGEX);
    jj_consume_token(LPAREN);
    expr1 = Expression();
    jj_consume_token(COMMA);
    expr2 = Expression();
                regexpr = document.createElement("sparql:BuiltInCall");
                Element call = document.createElement("sparql:call");
                Element args = document.createElement("sparql:args");
                regexpr.appendChild(call);
                regexpr.appendChild(args);
                call.setAttribute("rdf:resource",REGEX_IRI);
                args.setAttribute("rdf:parseType","Collection");
                args.appendChild(expr1);
                args.appendChild(expr2);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      expr3 = Expression();
                args.appendChild(expr3);
      break;
    default:
      jj_la1[64] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
                {if (true) return regexpr;}
    throw new Error("Missing return statement in function");
  }

  final public Element IRIrefOrFunction() throws ParseException {
 String iri;
    iri = IRIref();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAREN:
    case NIL:
                Element functionCall = document.createElement("sparql:FunctionCall");
                Element call = document.createElement("sparql:call");
                Element args = document.createElement("sparql:args");
                functionCall.appendChild(call);
                functionCall.appendChild(args);
      ArgList(args);
                call.setAttribute("rdf:resource",iri);
                {if (true) return functionCall;}
      break;
    default:
      jj_la1[65] = jj_gen;
      ;
    }
                Element expr = document.createElement("sparql:PrimaryElement");
                Element objectvalue = document.createElement("sparql:objectvalue");
                expr.appendChild(objectvalue);
                objectvalue.setAttribute("rdf:resource",iri);
                {if (true) return expr;}
    throw new Error("Missing return statement in function");
  }

  final public void RDFLiteral(SubjectOrObject elem) throws ParseException {
 String str; Token t;
    str = String();
                Text literal = document.createTextNode(str);
                elem.appendChild(literal);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LANGTAG:
    case DATATYPE:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LANGTAG:
        t = jj_consume_token(LANGTAG);
                elem.setAttribute("xml:lang",t.image.substring(1));
        break;
      case DATATYPE:
        jj_consume_token(DATATYPE);
        str = IRIref();
                elem.setAttribute("rdf:datatype",str);
        break;
      default:
        jj_la1[66] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[67] = jj_gen;
      ;
    }
  }

  final public void NumericLiteral(SubjectOrObject elem) throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER:
    case DECIMAL:
    case DOUBLE:
      NumericLiteralUnsigned(elem);
      break;
    case INTEGER_POSITIVE:
    case DECIMAL_POSITIVE:
    case DOUBLE_POSITIVE:
      NumericLiteralPositive(elem);
      break;
    case INTEGER_NEGATIVE:
    case DECIMAL_NEGATIVE:
    case DOUBLE_NEGATIVE:
      NumericLiteralNegative(elem);
      break;
    default:
      jj_la1[68] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void NumericLiteralUnsigned(SubjectOrObject elem) throws ParseException {
 Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER:
      t = jj_consume_token(INTEGER);
                elem.setAttribute("rdf:datatype",NON_NEGATIVE_INTEGER_IRI);
      break;
    case DECIMAL:
      t = jj_consume_token(DECIMAL);
                elem.setAttribute("rdf:datatype",DECIMAL_IRI);
      break;
    case DOUBLE:
      t = jj_consume_token(DOUBLE);
                elem.setAttribute("rdf:datatype",DOUBLE_IRI);
      break;
    default:
      jj_la1[69] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                Text literal = document.createTextNode(t.image);
                elem.appendChild(literal);
  }

  final public void NumericLiteralPositive(SubjectOrObject elem) throws ParseException {
 Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER_POSITIVE:
      t = jj_consume_token(INTEGER_POSITIVE);
                elem.setAttribute("rdf:datatype",NON_NEGATIVE_INTEGER_IRI);
      break;
    case DECIMAL_POSITIVE:
      t = jj_consume_token(DECIMAL_POSITIVE);
                elem.setAttribute("rdf:datatype",DECIMAL_IRI);
      break;
    case DOUBLE_POSITIVE:
      t = jj_consume_token(DOUBLE_POSITIVE);
                elem.setAttribute("rdf:datatype",DOUBLE_IRI);
      break;
    default:
      jj_la1[70] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                Text literal = document.createTextNode(t.image);
                elem.appendChild(literal);
  }

  final public void NumericLiteralNegative(SubjectOrObject elem) throws ParseException {
 Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER_NEGATIVE:
      t = jj_consume_token(INTEGER_NEGATIVE);
                elem.setAttribute("rdf:datatype",NON_POSITIVE_INTEGER_IRI);
      break;
    case DECIMAL_NEGATIVE:
      t = jj_consume_token(DECIMAL_NEGATIVE);
                elem.setAttribute("rdf:datatype",DECIMAL_IRI);
      break;
    case DOUBLE_NEGATIVE:
      t = jj_consume_token(DOUBLE_NEGATIVE);
                elem.setAttribute("rdf:datatype",DOUBLE_IRI);
      break;
    default:
      jj_la1[71] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                Text literal = document.createTextNode(t.image);
                elem.appendChild(literal);
  }

  final public String BooleanLiteral() throws ParseException {
 Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TRUE:
      t = jj_consume_token(TRUE);
      break;
    case FALSE:
      t = jj_consume_token(FALSE);
                {if (true) return t.image;}
      break;
    default:
      jj_la1[72] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public String String() throws ParseException {
 Token t; String str;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STRING_LITERAL1:
      t = jj_consume_token(STRING_LITERAL1);
                str = t.image.substring(1,t.image.length()-1);
      break;
    case STRING_LITERAL2:
      t = jj_consume_token(STRING_LITERAL2);
                str = t.image.substring(1,t.image.length()-1);
      break;
    case STRING_LITERAL_LONG1:
      t = jj_consume_token(STRING_LITERAL_LONG1);
                str = t.image.substring(3,t.image.length()-3);
      break;
    case STRING_LITERAL_LONG2:
      t = jj_consume_token(STRING_LITERAL_LONG2);
                str = t.image.substring(3,t.image.length()-3);
      break;
    default:
      jj_la1[73] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return str;}
    throw new Error("Missing return statement in function");
  }

  final public String IRIref() throws ParseException {
 Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IRI_REF:
      t = jj_consume_token(IRI_REF);
                {if (true) return t.image.substring(1,t.image.length()-1);}
      break;
    case PNAME_NS:
    case PNAME_LN:
      t = PrefixedName();
                int colonIndex = t.image.indexOf(':');
                String prefixName = t.image.substring(0,colonIndex);
                String suffix = t.image.substring(colonIndex+1);
                {if (true) return listPrefix.get(prefixName) + suffix;}
      break;
    default:
      jj_la1[74] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public Token PrefixedName() throws ParseException {
 Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PNAME_LN:
      t = jj_consume_token(PNAME_LN);
      break;
    case PNAME_NS:
      t = jj_consume_token(PNAME_NS);
      break;
    default:
      jj_la1[75] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                {if (true) return t;}
    throw new Error("Missing return statement in function");
  }

  final public String BlankNode() throws ParseException {
 Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BLANK_NODE_LABEL:
      t = jj_consume_token(BLANK_NODE_LABEL);
                {if (true) return "_:b" + t.image.substring(2);}
      break;
    case ANON:
      jj_consume_token(ANON);
                {if (true) return "_:a" + blankNodeCounter;}
                blankNodeCounter ++;
      break;
    default:
      jj_la1[76] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_1(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(0, xla); }
  }

  final private boolean jj_3R_65() {
    if (jj_3R_71()) return true;
    return false;
  }

  final private boolean jj_3R_29() {
    if (jj_3R_36()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_37()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_91() {
    if (jj_3R_101()) return true;
    return false;
  }

  final private boolean jj_3R_67() {
    if (jj_3R_83()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_91()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_63() {
    if (jj_3R_69()) return true;
    return false;
  }

  final private boolean jj_3R_27() {
    if (jj_3R_29()) return true;
    return false;
  }

  final private boolean jj_3R_90() {
    if (jj_scan_token(VAR2)) return true;
    return false;
  }

  final private boolean jj_3R_59() {
    if (jj_3R_19()) return true;
    return false;
  }

  final private boolean jj_3R_62() {
    if (jj_3R_68()) return true;
    return false;
  }

  final private boolean jj_3R_52() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_59()) {
    jj_scanpos = xsp;
    if (jj_3R_60()) {
    jj_scanpos = xsp;
    if (jj_3R_61()) {
    jj_scanpos = xsp;
    if (jj_3R_62()) {
    jj_scanpos = xsp;
    if (jj_3R_63()) {
    jj_scanpos = xsp;
    if (jj_3R_64()) {
    jj_scanpos = xsp;
    if (jj_3R_65()) return true;
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_89() {
    if (jj_scan_token(VAR1)) return true;
    return false;
  }

  final private boolean jj_3R_71() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_89()) {
    jj_scanpos = xsp;
    if (jj_3R_90()) return true;
    }
    return false;
  }

  final private boolean jj_3R_104() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(10)) {
    jj_scanpos = xsp;
    if (jj_scan_token(9)) return true;
    }
    return false;
  }

  final private boolean jj_3R_47() {
    if (jj_3R_52()) return true;
    return false;
  }

  final private boolean jj_3R_35() {
    if (jj_scan_token(GE)) return true;
    return false;
  }

  final private boolean jj_3R_93() {
    if (jj_scan_token(REGEX)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_46() {
    if (jj_scan_token(MINUS)) return true;
    if (jj_3R_52()) return true;
    return false;
  }

  final private boolean jj_3R_95() {
    if (jj_3R_104()) return true;
    return false;
  }

  final private boolean jj_3R_94() {
    if (jj_scan_token(IRI_REF)) return true;
    return false;
  }

  final private boolean jj_3R_82() {
    if (jj_3R_93()) return true;
    return false;
  }

  final private boolean jj_3R_45() {
    if (jj_scan_token(PLUS)) return true;
    if (jj_3R_52()) return true;
    return false;
  }

  final private boolean jj_3R_83() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_94()) {
    jj_scanpos = xsp;
    if (jj_3R_95()) return true;
    }
    return false;
  }

  final private boolean jj_3R_34() {
    if (jj_scan_token(LE)) return true;
    return false;
  }

  final private boolean jj_3R_44() {
    if (jj_scan_token(BANG)) return true;
    if (jj_3R_52()) return true;
    return false;
  }

  final private boolean jj_3R_81() {
    if (jj_scan_token(IS_LITERAL)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_99() {
    if (jj_scan_token(STRING_LITERAL_LONG2)) return true;
    return false;
  }

  final private boolean jj_3R_33() {
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_38() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_44()) {
    jj_scanpos = xsp;
    if (jj_3R_45()) {
    jj_scanpos = xsp;
    if (jj_3R_46()) {
    jj_scanpos = xsp;
    if (jj_3R_47()) return true;
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_109() {
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_98() {
    if (jj_scan_token(STRING_LITERAL_LONG1)) return true;
    return false;
  }

  final private boolean jj_3R_108() {
    if (jj_scan_token(NIL)) return true;
    return false;
  }

  final private boolean jj_3R_97() {
    if (jj_scan_token(STRING_LITERAL2)) return true;
    return false;
  }

  final private boolean jj_3R_101() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_108()) {
    jj_scanpos = xsp;
    if (jj_3R_109()) return true;
    }
    return false;
  }

  final private boolean jj_3R_28() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_30()) {
    jj_scanpos = xsp;
    if (jj_3R_31()) {
    jj_scanpos = xsp;
    if (jj_3R_32()) {
    jj_scanpos = xsp;
    if (jj_3R_33()) {
    jj_scanpos = xsp;
    if (jj_3R_34()) {
    jj_scanpos = xsp;
    if (jj_3R_35()) return true;
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_30() {
    if (jj_scan_token(EQ)) return true;
    return false;
  }

  final private boolean jj_3R_80() {
    if (jj_scan_token(IS_BLANK)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_88() {
    if (jj_scan_token(FALSE)) return true;
    return false;
  }

  final private boolean jj_3R_32() {
    if (jj_scan_token(LT)) return true;
    return false;
  }

  final private boolean jj_3R_96() {
    if (jj_scan_token(STRING_LITERAL1)) return true;
    return false;
  }

  final private boolean jj_3R_84() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_96()) {
    jj_scanpos = xsp;
    if (jj_3R_97()) {
    jj_scanpos = xsp;
    if (jj_3R_98()) {
    jj_scanpos = xsp;
    if (jj_3R_99()) return true;
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_79() {
    if (jj_scan_token(IS_URI)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_31() {
    if (jj_scan_token(NE)) return true;
    return false;
  }

  final private boolean jj_3R_48() {
    if (jj_scan_token(STAR)) return true;
    return false;
  }

  final private boolean jj_3R_39() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_48()) {
    jj_scanpos = xsp;
    if (jj_3R_49()) return true;
    }
    return false;
  }

  final private boolean jj_3R_70() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(51)) {
    jj_scanpos = xsp;
    if (jj_3R_88()) return true;
    }
    return false;
  }

  final private boolean jj_3R_49() {
    if (jj_scan_token(SLASH)) return true;
    return false;
  }

  final private boolean jj_3R_78() {
    if (jj_scan_token(IS_IRI)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_58() {
    if (jj_scan_token(DOUBLE_NEGATIVE)) return true;
    return false;
  }

  final private boolean jj_3_1() {
    if (jj_3R_19()) return true;
    return false;
  }

  final private boolean jj_3R_26() {
    if (jj_3R_27()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_28()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_57() {
    if (jj_scan_token(DECIMAL_NEGATIVE)) return true;
    return false;
  }

  final private boolean jj_3R_77() {
    if (jj_scan_token(SAME_TERM)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_56() {
    if (jj_scan_token(INTEGER_NEGATIVE)) return true;
    return false;
  }

  final private boolean jj_3R_51() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_56()) {
    jj_scanpos = xsp;
    if (jj_3R_57()) {
    jj_scanpos = xsp;
    if (jj_3R_58()) return true;
    }
    }
    return false;
  }

  final private boolean jj_3R_24() {
    if (jj_3R_26()) return true;
    return false;
  }

  final private boolean jj_3R_36() {
    if (jj_3R_38()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_39()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_25() {
    if (jj_scan_token(SC_AND)) return true;
    return false;
  }

  final private boolean jj_3R_55() {
    if (jj_scan_token(DOUBLE_POSITIVE)) return true;
    return false;
  }

  final private boolean jj_3R_76() {
    if (jj_scan_token(BOUND)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_54() {
    if (jj_scan_token(DECIMAL_POSITIVE)) return true;
    return false;
  }

  final private boolean jj_3R_53() {
    if (jj_scan_token(INTEGER_POSITIVE)) return true;
    return false;
  }

  final private boolean jj_3R_50() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_53()) {
    jj_scanpos = xsp;
    if (jj_3R_54()) {
    jj_scanpos = xsp;
    if (jj_3R_55()) return true;
    }
    }
    return false;
  }

  final private boolean jj_3R_75() {
    if (jj_scan_token(DTYPE)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_23() {
    if (jj_scan_token(SC_OR)) return true;
    return false;
  }

  final private boolean jj_3R_22() {
    if (jj_3R_24()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_25()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_107() {
    if (jj_scan_token(DOUBLE)) return true;
    return false;
  }

  final private boolean jj_3R_74() {
    if (jj_scan_token(LANGMATCHES)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_106() {
    if (jj_scan_token(DECIMAL)) return true;
    return false;
  }

  final private boolean jj_3R_43() {
    if (jj_3R_51()) return true;
    return false;
  }

  final private boolean jj_3R_105() {
    if (jj_scan_token(INTEGER)) return true;
    return false;
  }

  final private boolean jj_3R_100() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_105()) {
    jj_scanpos = xsp;
    if (jj_3R_106()) {
    jj_scanpos = xsp;
    if (jj_3R_107()) return true;
    }
    }
    return false;
  }

  final private boolean jj_3R_73() {
    if (jj_scan_token(LANG)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_87() {
    if (jj_3R_51()) return true;
    return false;
  }

  final private boolean jj_3R_86() {
    if (jj_3R_50()) return true;
    return false;
  }

  final private boolean jj_3R_69() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_85()) {
    jj_scanpos = xsp;
    if (jj_3R_86()) {
    jj_scanpos = xsp;
    if (jj_3R_87()) return true;
    }
    }
    return false;
  }

  final private boolean jj_3R_85() {
    if (jj_3R_100()) return true;
    return false;
  }

  final private boolean jj_3R_61() {
    if (jj_3R_67()) return true;
    return false;
  }

  final private boolean jj_3R_72() {
    if (jj_scan_token(STR)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_66() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_72()) {
    jj_scanpos = xsp;
    if (jj_3R_73()) {
    jj_scanpos = xsp;
    if (jj_3R_74()) {
    jj_scanpos = xsp;
    if (jj_3R_75()) {
    jj_scanpos = xsp;
    if (jj_3R_76()) {
    jj_scanpos = xsp;
    if (jj_3R_77()) {
    jj_scanpos = xsp;
    if (jj_3R_78()) {
    jj_scanpos = xsp;
    if (jj_3R_79()) {
    jj_scanpos = xsp;
    if (jj_3R_80()) {
    jj_scanpos = xsp;
    if (jj_3R_81()) {
    jj_scanpos = xsp;
    if (jj_3R_82()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_103() {
    if (jj_scan_token(DATATYPE)) return true;
    return false;
  }

  final private boolean jj_3R_42() {
    if (jj_3R_50()) return true;
    return false;
  }

  final private boolean jj_3R_40() {
    if (jj_scan_token(PLUS)) return true;
    return false;
  }

  final private boolean jj_3R_37() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_40()) {
    jj_scanpos = xsp;
    if (jj_3R_41()) {
    jj_scanpos = xsp;
    if (jj_3R_42()) {
    jj_scanpos = xsp;
    if (jj_3R_43()) return true;
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_21() {
    if (jj_3R_22()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_23()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_102() {
    if (jj_scan_token(LANGTAG)) return true;
    return false;
  }

  final private boolean jj_3R_92() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_102()) {
    jj_scanpos = xsp;
    if (jj_3R_103()) return true;
    }
    return false;
  }

  final private boolean jj_3R_68() {
    if (jj_3R_84()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_92()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_20() {
    if (jj_3R_21()) return true;
    return false;
  }

  final private boolean jj_3R_19() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_20()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_41() {
    if (jj_scan_token(MINUS)) return true;
    return false;
  }

  final private boolean jj_3R_64() {
    if (jj_3R_70()) return true;
    return false;
  }

  final private boolean jj_3R_60() {
    if (jj_3R_66()) return true;
    return false;
  }

  public SparqlTokenManager token_source;
  SimpleCharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  public boolean lookingAhead = false;
  private boolean jj_semLA;
  private int jj_gen;
  final private int[] jj_la1 = new int[77];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static private int[] jj_la1_2;
  static private int[] jj_la1_3;
  static {
      jj_la1_0();
      jj_la1_1();
      jj_la1_2();
      jj_la1_3();
   }
   private static void jj_la1_0() {
      jj_la1_0 = new int[] {0x3900000,0x40000,0x80000,0x600000,0x600000,0x3000,0x3000,0x0,0x0,0x3700,0x3700,0x0,0x0,0x0,0x700,0x0,0x10000000,0xc000000,0x8000000,0x4000000,0xc000000,0xc0003700,0xc0000000,0x3700,0xc0003700,0x3f00,0x0,0x0,0x0,0x3f00,0x3f00,0x0,0x0,0x0,0x700,0x0,0x0,0x3f00,0x3f00,0x0,0x3f00,0x0,0x23700,0x23700,0x0,0x23700,0x0,0x3f00,0x3f00,0x3f00,0x3700,0x3000,0xf00,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x3700,0x3700,0x0,0x0,0x0,0x4000,0x4000,0x0,0x0,0x0,0x0,0x0,0x0,0x700,0x600,0x800,};
   }
   private static void jj_la1_1() {
      jj_la1_1 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2,0x2,0x0,0x0,0x2,0x4,0x2,0x1,0x4,0x0,0x0,0x0,0x0,0x0,0x7ff00,0x0,0x7ff00,0x7ff00,0x7fd80000,0xb0,0xb0,0x0,0x7fd80000,0x7fd80000,0x0,0x30,0x40,0x7ff00,0x0,0x0,0x7fd80000,0x7fd80000,0x0,0x7fd80000,0x0,0x0,0x0,0x0,0x0,0x0,0x7fd80000,0x7fd80000,0x7fd80000,0x0,0x0,0x7fd80000,0x0,0x0,0x0,0x0,0x7e000000,0x7e000000,0x0,0x0,0x7fdfff00,0x7fdfff00,0x7ff00,0x0,0x0,0x0,0x0,0x7fc00000,0x1c00000,0xe000000,0x70000000,0x180000,0x0,0x0,0x0,0x0,};
   }
   private static void jj_la1_2() {
      jj_la1_2 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x80000000,0x0,0x0,0x0,0x80000000,0x0,0x400,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80,0x0,0x80,0x80,0x52f8,0x400,0x400,0x20000,0x52f8,0x52f8,0x20000,0x400,0x0,0x0,0x10000,0x280,0x52f8,0x52f8,0x20000,0x52f8,0x8000,0x0,0x0,0x10000,0x0,0x1080,0x52f8,0x52f8,0x4278,0x0,0x0,0x4278,0x8000000,0x10000000,0xfc0000,0xfc0000,0x60000000,0x60000000,0x80000000,0x80000000,0x610000f8,0xf8,0x0,0x10000,0x280,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x78,0x0,0x0,0x4000,};
   }
   private static void jj_la1_3() {
      jj_la1_3 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1,0x1,0x0,0x0,0x0,0x0,0x0,0x2,0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
   }
  final private JJCalls[] jj_2_rtns = new JJCalls[1];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  public Sparql(java.io.InputStream stream) {
     this(stream, null);
  }
  public Sparql(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new SimpleCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new SparqlTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 77; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 77; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public Sparql(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new SparqlTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 77; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 77; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public Sparql(SparqlTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 77; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(SparqlTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 77; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static private final class LookaheadSuccess extends java.lang.Error { }
  final private LookaheadSuccess jj_ls = new LookaheadSuccess();
  final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    if (jj_scanpos.kind != kind) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
    return false;
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration e = jj_expentries.elements(); e.hasMoreElements();) {
        int[] oldentry = (int[])(e.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[105];
    for (int i = 0; i < 105; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 77; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
          if ((jj_la1_2[i] & (1<<j)) != 0) {
            la1tokens[64+j] = true;
          }
          if ((jj_la1_3[i] & (1<<j)) != 0) {
            la1tokens[96+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 105; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

  final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 1; i++) {
    try {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
          }
        }
        p = p.next;
      } while (p != null);
      } catch(LookaheadSuccess ls) { }
    }
    jj_rescan = false;
  }

  final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
